-- View: idm_rpt_cfg.idmrpt_role_res_prd_count_v

-- DROP VIEW idm_rpt_cfg.idmrpt_role_res_prd_count_v;

CREATE OR REPLACE VIEW idm_rpt_cfg.idmrpt_role_res_prd_count_v AS 
 SELECT ''::text || count(1) AS item_count,
    1 AS "position",
    'Roles'::text AS type,
    roles_dataset_main.idv_name
   FROM ( SELECT idmrpt_role.role_id,
                CASE
                    WHEN btrim(idmrpt_rpt_driver.idv_host) = btrim(idmrpt_rpt_driver.idv_name) THEN idmrpt_rpt_driver.idv_name
                    ELSE ((idmrpt_rpt_driver.idv_name || ' ('::text) || idmrpt_rpt_driver.idv_host) || ')'::text
                END AS idv_name
           FROM idm_rpt_cfg.idmrpt_rpt_driver_v idmrpt_rpt_driver,
            idm_rpt_cfg.idmrpt_idv_v idmrpt_idv,
            idm_rpt_cfg.idmrpt_role_cs_v idmrpt_role
          WHERE idmrpt_rpt_driver.idv_id = idmrpt_idv.idv_id AND idmrpt_idv.idv_id = idmrpt_role.idv_id AND
                CASE
                    WHEN idmrpt_role.rpt_drv_id IS NULL THEN true
                    ELSE idmrpt_rpt_driver.rpt_drv_id = idmrpt_role.rpt_drv_id
                END
          ORDER BY (
                CASE
                    WHEN btrim(idmrpt_rpt_driver.idv_host) = btrim(idmrpt_rpt_driver.idv_name) THEN idmrpt_rpt_driver.idv_name
                    ELSE ((idmrpt_rpt_driver.idv_name || ' ('::text) || idmrpt_rpt_driver.idv_host) || ')'::text
                END), idmrpt_role.role_id) roles_dataset_main
  GROUP BY 'Roles'::text, roles_dataset_main.idv_name
UNION
 SELECT ''::text || count(1) AS item_count,
    2 AS "position",
    'Resources'::text AS type,
    resources_dataset_main.idv_name
   FROM ( SELECT idmrpt_resource.res_id,
                CASE
                    WHEN btrim(idmrpt_rpt_driver.idv_host) = btrim(idmrpt_rpt_driver.idv_name) THEN idmrpt_rpt_driver.idv_name
                    ELSE ((idmrpt_rpt_driver.idv_name || ' ('::text) || idmrpt_rpt_driver.idv_host) || ')'::text
                END AS idv_name
           FROM idm_rpt_cfg.idmrpt_rpt_driver_v idmrpt_rpt_driver,
            idm_rpt_cfg.idmrpt_idv_v idmrpt_idv,
            idm_rpt_cfg.idmrpt_resource_cs_v idmrpt_resource
          WHERE idmrpt_rpt_driver.idv_id = idmrpt_idv.idv_id AND idmrpt_idv.idv_id = idmrpt_resource.idv_id AND
                CASE
                    WHEN idmrpt_resource.rpt_drv_id IS NULL THEN true
                    ELSE idmrpt_rpt_driver.rpt_drv_id = idmrpt_resource.rpt_drv_id
                END
          ORDER BY (
                CASE
                    WHEN btrim(idmrpt_rpt_driver.idv_host) = btrim(idmrpt_rpt_driver.idv_name) THEN idmrpt_rpt_driver.idv_name
                    ELSE ((idmrpt_rpt_driver.idv_name || ' ('::text) || idmrpt_rpt_driver.idv_host) || ')'::text
                END), idmrpt_resource.res_id) resources_dataset_main
  GROUP BY 'Resources'::text, resources_dataset_main.idv_name
UNION
 SELECT ''::text || count(1) AS item_count,
    3 AS "position",
    'Provisioning Request Definitions'::text AS type,
    prds_dataset_main.idv_name
   FROM ( SELECT idmrpt_idv_prd.prd_id,
                CASE
                    WHEN btrim(idmrpt_rpt_driver.idv_host) = btrim(idmrpt_rpt_driver.idv_name) THEN idmrpt_rpt_driver.idv_name
                    ELSE ((idmrpt_rpt_driver.idv_name || ' ('::text) || idmrpt_rpt_driver.idv_host) || ')'::text
                END AS idv_name
           FROM idm_rpt_cfg.idmrpt_rpt_driver_v idmrpt_rpt_driver,
            idm_rpt_cfg.idmrpt_idv_v idmrpt_idv,
            idm_rpt_cfg.idmrpt_idv_prd_cs_v idmrpt_idv_prd
          WHERE idmrpt_rpt_driver.idv_id = idmrpt_idv.idv_id AND idmrpt_idv.idv_id = idmrpt_idv_prd.idv_id AND
                CASE
                    WHEN idmrpt_idv_prd.rpt_drv_id IS NULL THEN true
                    ELSE idmrpt_rpt_driver.rpt_drv_id = idmrpt_idv_prd.rpt_drv_id
                END
          ORDER BY (
                CASE
                    WHEN btrim(idmrpt_rpt_driver.idv_host) = btrim(idmrpt_rpt_driver.idv_name) THEN idmrpt_rpt_driver.idv_name
                    ELSE ((idmrpt_rpt_driver.idv_name || ' ('::text) || idmrpt_rpt_driver.idv_host) || ')'::text
                END), idmrpt_idv_prd.prd_id) prds_dataset_main
  GROUP BY 'Provisioning Request Definitions'::text, prds_dataset_main.idv_name;

ALTER TABLE idm_rpt_cfg.idmrpt_role_res_prd_count_v
  OWNER TO idm_rpt_cfg;
GRANT ALL ON TABLE idm_rpt_cfg.idmrpt_role_res_prd_count_v TO idm_rpt_cfg;
GRANT SELECT ON TABLE idm_rpt_cfg.idmrpt_role_res_prd_count_v TO idmrptuser;
